//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: iris/guardian/tx.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Msg defines the guardian Msg service
///
/// Usage: instantiate `Irishub_Guardian_MsgClient`, then call methods of this protocol to make API calls.
internal protocol Irishub_Guardian_MsgClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Irishub_Guardian_MsgClientInterceptorFactoryProtocol? { get }

  func addSuper(
    _ request: Irishub_Guardian_MsgAddSuper,
    callOptions: CallOptions?
  ) -> UnaryCall<Irishub_Guardian_MsgAddSuper, Irishub_Guardian_MsgAddSuperResponse>

  func deleteSuper(
    _ request: Irishub_Guardian_MsgDeleteSuper,
    callOptions: CallOptions?
  ) -> UnaryCall<Irishub_Guardian_MsgDeleteSuper, Irishub_Guardian_MsgDeleteSuperResponse>
}

extension Irishub_Guardian_MsgClientProtocol {
  internal var serviceName: String {
    return "irishub.guardian.Msg"
  }

  /// AddSuper defines a method for adding a super account
  ///
  /// - Parameters:
  ///   - request: Request to send to AddSuper.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func addSuper(
    _ request: Irishub_Guardian_MsgAddSuper,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Irishub_Guardian_MsgAddSuper, Irishub_Guardian_MsgAddSuperResponse> {
    return self.makeUnaryCall(
      path: "/irishub.guardian.Msg/AddSuper",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeAddSuperInterceptors() ?? []
    )
  }

  /// DeleteSuper defines a method for deleting a super account
  ///
  /// - Parameters:
  ///   - request: Request to send to DeleteSuper.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func deleteSuper(
    _ request: Irishub_Guardian_MsgDeleteSuper,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Irishub_Guardian_MsgDeleteSuper, Irishub_Guardian_MsgDeleteSuperResponse> {
    return self.makeUnaryCall(
      path: "/irishub.guardian.Msg/DeleteSuper",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeDeleteSuperInterceptors() ?? []
    )
  }
}

internal protocol Irishub_Guardian_MsgClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'addSuper'.
  func makeAddSuperInterceptors() -> [ClientInterceptor<Irishub_Guardian_MsgAddSuper, Irishub_Guardian_MsgAddSuperResponse>]

  /// - Returns: Interceptors to use when invoking 'deleteSuper'.
  func makeDeleteSuperInterceptors() -> [ClientInterceptor<Irishub_Guardian_MsgDeleteSuper, Irishub_Guardian_MsgDeleteSuperResponse>]
}

internal final class Irishub_Guardian_MsgClient: Irishub_Guardian_MsgClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Irishub_Guardian_MsgClientInterceptorFactoryProtocol?

  /// Creates a client for the irishub.guardian.Msg service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Irishub_Guardian_MsgClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Msg defines the guardian Msg service
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Irishub_Guardian_MsgProvider: CallHandlerProvider {
  var interceptors: Irishub_Guardian_MsgServerInterceptorFactoryProtocol? { get }

  /// AddSuper defines a method for adding a super account
  func addSuper(request: Irishub_Guardian_MsgAddSuper, context: StatusOnlyCallContext) -> EventLoopFuture<Irishub_Guardian_MsgAddSuperResponse>

  /// DeleteSuper defines a method for deleting a super account
  func deleteSuper(request: Irishub_Guardian_MsgDeleteSuper, context: StatusOnlyCallContext) -> EventLoopFuture<Irishub_Guardian_MsgDeleteSuperResponse>
}

extension Irishub_Guardian_MsgProvider {
  internal var serviceName: Substring { return "irishub.guardian.Msg" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "AddSuper":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Irishub_Guardian_MsgAddSuper>(),
        responseSerializer: ProtobufSerializer<Irishub_Guardian_MsgAddSuperResponse>(),
        interceptors: self.interceptors?.makeAddSuperInterceptors() ?? [],
        userFunction: self.addSuper(request:context:)
      )

    case "DeleteSuper":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Irishub_Guardian_MsgDeleteSuper>(),
        responseSerializer: ProtobufSerializer<Irishub_Guardian_MsgDeleteSuperResponse>(),
        interceptors: self.interceptors?.makeDeleteSuperInterceptors() ?? [],
        userFunction: self.deleteSuper(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Irishub_Guardian_MsgServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'addSuper'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeAddSuperInterceptors() -> [ServerInterceptor<Irishub_Guardian_MsgAddSuper, Irishub_Guardian_MsgAddSuperResponse>]

  /// - Returns: Interceptors to use when handling 'deleteSuper'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeDeleteSuperInterceptors() -> [ServerInterceptor<Irishub_Guardian_MsgDeleteSuper, Irishub_Guardian_MsgDeleteSuperResponse>]
}
